#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "module3.h"

char *version = "CIS 301 PIC 16C84 Assembler\n"; 

opcode_t  ot[] ={{"equ", EQU},
                 {"org", ORG},  /*arithmetic & logic*/
                 {"addlw", 0X3e00,{{8,0}}},  /*arithmetic & logic*/
		 {"addwf", 0X0700,{{7,0},{1,7}}},
		 {"andlw", 0X3900,{{8,0}}},
		 {"andwf", 0X0500,{{7,0},{1,7}}},
		 {"clrf", 0X0180,{{7,0},{1,7}}},
		 {"clrw", 0X0100,{{0,0}}},
		 {"comf", 0X0900,{{7,0},{1,7}}},
		 {"decf", 0X0300,{{7,0},{1,7}}},
		 {"incf", 0X0a00,{{7,0},{1,7}}},
		 {"iorlw", 0X3800,{{8,0}}},
		 {"iorwf", 0X0400,{{7,0},{1,7}}},
		 {"movlw", 0X3000,{{8,0}}},
		 {"movf", 0X0800,{{7,0},{1,7}}},
		 {"rlf", 0X0d00,{{7,0},{1,7}}},
		 {"rrf", 0X0c00,{{7,0},{1,7}}},
		 {"sublw", 0X3c00,{{8,0}}},
		 {"subwf", 0X0200,{{7,0},{1,7}}},
		 {"swapf", 0X0e00,{{7,0},{1,7}}},
		 {"xorlw", 0X3a00,{{8,0}}},
		 {"xorwf", 0X0600,{{7,0},{1,7}}},   
		 {"movwf", 0X0080,{{7,0}}},
		 {"call",0X2000,{{11,0}}},     /*program control*/
		 {"decfsz",0X0b00,{{7,0},{1,7}}},
		 {"goto",0X2800,{{11,0}}},
		 {"incfsz",0X0f00,{{7,0},{1,7}}},
		 {"retfie",0X0009,{{0,0}}},
		 {"retlw",0X3400,{{8,0}}},
		 {"return",0X0008,{{0,0}}},
		 {"bcf",0X1000,{{7,0},{3,7}}},
		 {"bsf",0X1400,{{7,0},{3,7}}},
		 {"btfsc",0X1800,{{7,0},{3,7}}},
		 {"btfss",0X1c00,{{7,0},{3,7}}},
		 {"clrwdt",0X0064,{{0,0}}},
		 {"nop",0X0000,{{0,0}}},
		 {"sleep",0X0063,{{0,0}}},
		 {"option",0X0062,{{0,0}}},
		 {"tris",0X0060,{{3,0}}},
		 {0,0}};



#if 0		 
main()
{
printf("Enter the opcode\n");
gets(opcode);
opcode_lookup(opcode);
}
#endif

struct opcode_table *opcode_lookup(char *opcode) 
{
struct opcode_table *ot_ptr;
char *op;


   for(op=opcode;*op;op++)      /*forces opcode to lower case*/
     *op=tolower(*op);
     
   for(ot_ptr=ot;ot_ptr->opcode_name;ot_ptr++) { 
      if (!strcmp(opcode,ot_ptr->opcode_name)) {
 	return ot_ptr;
      }
   }
   return NULL;
}    
    			 
