/*Chelito DeSilva*/
/*November 1994*/
/*CIS 301*/

#include <stdio.h>
#include <ctype.h>
#include <string.h>

int tokenize(char *line, char *tokens[]);
void identify(char *tokens[], int numtok);
extern char *label, *opcode, *operands;

#if 0
main()
{
   char  name[80],*fml[4];
   int nt;
   while (1) {
      printf("Enter command line\n");   
      gets (name);
      printf("'%d'\n",nt=tokenize(name,fml));
      if (!nt) break;
      identify(fml,nt);
      printf("label=%s opcode=%s operands=%s\n",label, opcode, operands);
   }
}
#endif
/*tokenize breaks a line up into tokens, each separated by a null*/
int tokenize(char *line, char *tokens[])
{
   char **t;
   
      t=tokens;   
    
      while (1) {    
        
        for(;isspace(*line);line++);        /*finds the first character*/
                                            /*that is not white space*/
           if (*line==';'||!*line)           /*check for EOL*/
              return t-tokens;
         
           *t++ = line;                      /*assigns ptr to next token*/ 
          
        for(;!isspace(*line) && *line ;line++); /* finds end of token*/
          
           if (!*line)           /*check for EOL*/
              return t-tokens;
          
           *line++ = 0;                    /*places null at end of ea. token*/
      
   }
   
} 
 
 /*identify identifies the label, opcode, and operand in the tokens list*/
 void identify(char *tokens[], int numtok)
 {
 char c;
 char *tmp;
 
 if (tmp=strchr(*tokens,':'))
   *tmp=0;
    
 switch(numtok){
 	case 1: if (tmp){
 	            label=*tokens; opcode=0; operands=0; break;}
 	        else{ 
 	            label=0; opcode=*tokens; operands=0; break;}
    	case 2: if (tmp){
    	 	    label=*tokens; opcode=*++tokens; operands=0; break;}
    	        else{
    	 	    label=0; opcode=*tokens; operands=*++tokens; break;}
    	case 3: if (tmp){
    		     label=*tokens; opcode=*++tokens; operands=*++tokens;
    		     break;}
    	default: break;
    	}
}  

  	