#ifndef MODULE3_H
#define MODULE3_H

typedef struct {
   int width;
   int shift;
} operand_t, *operand_p;               

typedef struct opcode_table{
	     char *opcode_name;
	     unsigned  opcode_value;
             operand_t pos[4];               
}opcode_t,*opcode_p;
opcode_p opcode_lookup(char *opcode);

#define PSEUDO_OP 0x10000
#define EQU       0x10001
#define ORG       0x10002
#define LIST       0x10003
#define NOLIST       0x10004
#endif
