#ifndef MODULE2_H
#define MODULE2_H
#include "module3.h"
typedef struct backpatch_s {
	int address;
	operand_p pos;
        struct backpatch_s *next;
} backpatch_t, *backpatch_p;

typedef struct node_s{
	char *name;     /*name*/
	long val;       /*value*/
	backpatch_p backpatches;        
	struct node_s *next;  /*pointer to next node*/     
} node_t,*node_p;

void hash_init();
int hash(char *name);
node_p hash_insert(char *name, long val);
node_p hash_lookup(char *name);
void add_backpatch(char *s,int loc,operand_p pos);
void do_backpatch(char *s,long val,FILE *listfile); 
#endif
