
unsigned char ml_output[4096];
unsigned char *next_byte = ml_output;

write_word(int word)
{
   *next_byte++ = (word >> 8) & 255;
   *next_byte++ = word & 255;
}

unsigned read_word(int address)
{
   return (ml_output[address] << 8) + ml_output[address+1];
}

write_word_to_address(int address,int word)
{
   ml_output[address]   = (word >> 8) & 255;
   ml_output[address+1] = word & 255;
}

write_ml_file(char *filename)
{
   unsigned char *tmp;

   srecinit(filename);
   for (tmp = ml_output;tmp+16 < next_byte;tmp += 16)
      srecdata(16,tmp-ml_output,tmp);
   srecdata(next_byte - tmp,tmp-ml_output,tmp);
   srecend(0);
}
